/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateInstallationInteractionsCustomDataInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateInstallationInteractionsCustomDataInner{}

// CxTemplateInstallationInteractionsCustomDataInner struct for CxTemplateInstallationInteractionsCustomDataInner
type CxTemplateInstallationInteractionsCustomDataInner struct {
	InteractionId *string `json:"interaction_id,omitempty"`
	Name *string `json:"name,omitempty"`
	Tags []string `json:"tags,omitempty"`
}

// NewCxTemplateInstallationInteractionsCustomDataInner instantiates a new CxTemplateInstallationInteractionsCustomDataInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateInstallationInteractionsCustomDataInner() *CxTemplateInstallationInteractionsCustomDataInner {
	this := CxTemplateInstallationInteractionsCustomDataInner{}
	return &this
}

// NewCxTemplateInstallationInteractionsCustomDataInnerWithDefaults instantiates a new CxTemplateInstallationInteractionsCustomDataInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateInstallationInteractionsCustomDataInnerWithDefaults() *CxTemplateInstallationInteractionsCustomDataInner {
	this := CxTemplateInstallationInteractionsCustomDataInner{}
	return &this
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *CxTemplateInstallationInteractionsCustomDataInner) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationInteractionsCustomDataInner) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *CxTemplateInstallationInteractionsCustomDataInner) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *CxTemplateInstallationInteractionsCustomDataInner) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *CxTemplateInstallationInteractionsCustomDataInner) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationInteractionsCustomDataInner) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *CxTemplateInstallationInteractionsCustomDataInner) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *CxTemplateInstallationInteractionsCustomDataInner) SetName(v string) {
	o.Name = &v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *CxTemplateInstallationInteractionsCustomDataInner) GetTags() []string {
	if o == nil || IsNil(o.Tags) {
		var ret []string
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationInteractionsCustomDataInner) GetTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.Tags) {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *CxTemplateInstallationInteractionsCustomDataInner) HasTags() bool {
	if o != nil && !IsNil(o.Tags) {
		return true
	}

	return false
}

// SetTags gets a reference to the given []string and assigns it to the Tags field.
func (o *CxTemplateInstallationInteractionsCustomDataInner) SetTags(v []string) {
	o.Tags = v
}

func (o CxTemplateInstallationInteractionsCustomDataInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateInstallationInteractionsCustomDataInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Tags) {
		toSerialize["tags"] = o.Tags
	}
	return toSerialize, nil
}

type NullableCxTemplateInstallationInteractionsCustomDataInner struct {
	value *CxTemplateInstallationInteractionsCustomDataInner
	isSet bool
}

func (v NullableCxTemplateInstallationInteractionsCustomDataInner) Get() *CxTemplateInstallationInteractionsCustomDataInner {
	return v.value
}

func (v *NullableCxTemplateInstallationInteractionsCustomDataInner) Set(val *CxTemplateInstallationInteractionsCustomDataInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateInstallationInteractionsCustomDataInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateInstallationInteractionsCustomDataInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateInstallationInteractionsCustomDataInner(val *CxTemplateInstallationInteractionsCustomDataInner) *NullableCxTemplateInstallationInteractionsCustomDataInner {
	return &NullableCxTemplateInstallationInteractionsCustomDataInner{value: val, isSet: true}
}

func (v NullableCxTemplateInstallationInteractionsCustomDataInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateInstallationInteractionsCustomDataInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


